{--------------------------------------------------------------}
{
{   PPTVOX - exibidor interativo de apresentaes
[
{   Programa Principal
{
{   Autores: Antonio Borges, Bernard Condorcet e Mara Caldeira
{
{   Junho/2015
{
{   Verso original: julho/2008
{
{--------------------------------------------------------------}

program pptvox;

uses
  dvcrt,
  dvwin,

  windows,
  messages,
  SysUtils,

  ppvars,
  ppmsg,
  ppjanela,
  ppArq,
  ppproc,
  ppdesen,
  ppinic;

procedure finaliza;  forward;

{--------------------------------------------------------}
{     Diretrio de trabalho, estilos e figura de fundo
{--------------------------------------------------------}

procedure defineDirTrab;
var infDirTrab: char;
begin

    mensagem ('PPDIRTRA', 1); {('Informe o diretrio de trabalho');}
    delay (100);
    mensagem ('PPENTPAD', 1); {('Pressionando ENTER usarei o padro');}
    infDirTrab:= sintEditaCampo (dirEstilos, 1, wherey, 255, 80, true);

    if infDirTrab = ESC then
        finaliza;

    if dirEstilos = '' then
        getDir (0, dirEstilos);

    if not trocaDir(dirEstilos) then
        finaliza
    else
    begin
        writeln;
        mensagem ('PPIRETRA', 0); {('OK, irei trabalhar em : ');}
        sintWriteln (dirEstilos);

        figuraDeFundo:= (sintAmbiente('PPTVOX', 'FIGURADEFUNDO'));
        if not existeArq(trim(figuraDeFundo)) then
            figuraDeFundo := fundoPadrao;
    end;

end;

{--------------------------------------------------------}
{                       Inicializao
{--------------------------------------------------------}

// Abre a janeta do PPTVOX, ttulos, Inicializa as
// variaveis, Fontes, Cor do fundo, player e efeitos de
// teclado

procedure inicializa;
var jan: integer;
    dir: string;
begin
    // evita duas instncia deste programa simultaneas

    jan := findWindowEx(0, 0, 'dvwincrt', 'PPTVOX');
    if jan <> 0 then
        halt;

    // cabealho
    clrscr;
    setWindowText (crtWindow, 'PPTVOX');

    dir := sintAmbiente('PPTVOX', 'DIRPPTVOX');
    if dir = '' then
        dir := 'c:\winvox\som\pptvox';
    SintInic (0, dir);

    textBACKGROUND (BLUE);
    mensagem ('PPINIC', 0); {'PPTVOX - V:'}
    sintWriteln (versao);
    textBackground (BLACK);
    writeln;
    writeln ('PROJETO DOSVOX - Instituto Trcio Pacitti - NCE/UFRJ');
    writeln;

    // inicializaes

    getDir (0, dirPPX);

    inicializaVariaveis;
    inicializaConfigPlayer;
    inicializaCoresEFontes;

    if paramCount = 0 then
        defineDirTrab
    else
        begin
            if not pegaParamLinhaDeComando then
                finaliza;
        end;

    if not existeArq ('Padro PPTVOX.est') then
        geraArqPadrao;     // *********** melhorar com a resoluo da tela atual ************

end;

{--------------------------------------------------------------}
{                       termina o programa
{--------------------------------------------------------------}

// Mensagem do Fim do programa, finaliza a fala, e destroi a janela

procedure finaliza;
begin
    writeln;
    mensagem ('PPFIM', 0);  {'Fim do programa'}
    delay (100);
    sintSom ('PPSAIR');
    while sintFalando do waitMessage;

    delay (500);
    sintFim;
    doneWincrt;

end;

{--------------------------------------------------------}
{            Incio do programa PPTVOX.PAS
{--------------------------------------------------------}

begin
    inicializa;
    processa;
    finaliza;
end.
